package UroIrmPackage;

import java.util.*;
import UroIrmPackage.*;

public class DicomPref implements DicomDictionaryData {
	private Properties dico;
	private Properties pref ; 
	public static final String keyDicom = "DicomInfo";
	public static final String defaultValue = "0";
	
	/** value for GetArgument in order to have the information of "dict" 
		(in the class DicomDictionaryData)*/
	public static final int TAG =0;
	/** value for GetArgument in order to have the information of "dict" 
		(in the class DicomDictionaryData)*/
	public static final int CATEGORIE=1;
	/** value for GetArgument in order to have the information of "dict" 
		(in the class DicomDictionaryData)*/
	public static final int TYPE=2;

	public DicomPref(){
		dico = new Properties();
		for (int i=0; i<dict.length; i++) {
			String tag =dict[i].substring(0,4)+"," ;
			tag += dict[i].substring(4,8);
			tag += dict[i].substring(8,14) ; 
			dico.put(dict[i].substring(17),tag);
		}
		PrefSaveResult.load();
		pref = PrefSaveResult.getPref();
	}

/** return the dictionary */
	public  Properties getDictionary() {
		return dico;
	}

/** return the preferences */
	public Properties getPref(){
		return pref;
	}

/** give the keys of the preferencies*/
	public Enumeration getKeys(){
		return pref.propertyNames();
	}		
	
/** give  the keys of the dictionary */
	public Enumeration getDicoNames(){
		return dico.propertyNames();
	} 

/** find in the dictionary the type of the specific "key" */
	public String getArgument(String key,int type){
		StringTokenizer dicoData = new StringTokenizer(dico.getProperty(key),"=");
		String res="";
		switch (type) {
			case 2 :  
				res =  (String)dicoData.nextElement();
			case 1 : 
				res =  (String)dicoData.nextElement();
			case 0 : 	
				res =  (String)dicoData.nextElement();
				break;
			default : 
				res = null;
				break;	
		}
		return res;
	}

/** LinkedList of String[5] :
	0 = name of the tag
	1 = the tag ( example "0008,0012")
	2=  type Image ( cf dict)
	3 = type of the tag ( cf dict)
	4 = categorie (cf dict) 
*/
	public LinkedList  getDicomListValue(String value){
		LinkedList res = new LinkedList();
		int[] dataDefault = getPref(keyDicom,value);
		int i=0,count=0;
		for (Enumeration e = dico.propertyNames();e.hasMoreElements();){
			String data = (String)e.nextElement();
			int current = i%32;
			if (  (( 1<<current ) & dataDefault[count])!=0  ){
				String[] s = new String[5];
				StringTokenizer dicoData = new StringTokenizer(dico.getProperty(data),"=");
				s[0] = data;
				s[1] =(String)dicoData.nextElement();
				s[4] =(String)dicoData.nextElement();
				s[3] =(String)dicoData.nextElement();
				s[2] =(String)dicoData.nextElement();
				res.add(s);
			}
			if ( current == 31 ) 	
				count ++;
			i++;
		}
	return res;
	}

/** find in the preferencies the "value" of the specific "key"*/	
	public int[] getPref(String key,String value ){
		String res = pref.getProperty(key,value);
		int size = dico.size()/32 +1;
		int[] data= new int[size];
		int count = 0;
		boolean run = true;
		for (int i =0;i<2;i++){
			try{
				count =0;
				for (StringTokenizer chaine = new StringTokenizer(res,":"); chaine.hasMoreElements();){
					String text = (String)chaine.nextElement();
					data[count] = (new Integer(text)).intValue(); 
					count ++;
				}
				break;
			} catch( NumberFormatException e ){	res = value;}
		}
		return (data);
	}

/** save the preferencies */
	public boolean save(String key , String value){
		 return PrefSaveResult.save(key,value);
	}

	private static int s2i(String s){
		try{ return( (new Integer(s)).intValue());}
		 catch( NumberFormatException e ){	return -1;	}
	}
}
